# index

| C  | D |   |
| :--- | :--- | --- |
| [◎](https://github.com/universato/ac-library-rb/blob/master/lib/fenwick_tree.rb) | [◎G](https://github.com/universato/ac-library-rb/blob/master/document_ja/fenwick_tree.md)   |FenwickTree(BIT)|
| [◎](https://github.com/universato/ac-library-rb/blob/master/lib/segtree.rb) | [◎G](https://github.com/universato/ac-library-rb/blob/master/document_ja/segtree.md) |Segtree|
| [○](https://github.com/universato/ac-library-rb/blob/master/lib/lazy_segtree.rb) | [○G](https://github.com/universato/ac-library-rb/blob/master/document_ja/lazy_segtree.md)   |LazySegtree|
| [◎](https://github.com/universato/ac-library-rb/blob/master/lib/priority_queue.rb) | [◎G](https://github.com/universato/ac-library-rb/blob/master/document_ja/priority_queue.md)  |PriorityQueue|
| [◎](https://github.com/universato/ac-library-rb/blob/master/lib/suffix_array.rb) | [◎G](https://github.com/universato/ac-library-rb/blob/master/document_ja/string.md)  |suffix_array|
| [◎](https://github.com/universato/ac-library-rb/blob/master/lib/lcp_array.rb) | [◎G](https://github.com/universato/ac-library-rb/blob/master/document_ja/string.md)  |lcp_array|
| [◎](https://github.com/universato/ac-library-rb/blob/master/lib/z_algorithm.rb) | [◎G](https://github.com/universato/ac-library-rb/blob/master/document_ja/string.md)  |z_algorithm|
| [◎](https://github.com/universato/ac-library-rb/blob/master/lib/pow_mod.rb) | [◎G](https://github.com/universato/ac-library-rb/blob/master/document_ja/math.md)  |pow_mod|
| [◎](https://github.com/universato/ac-library-rb/blob/master/lib/inv_mod.rb) | [◎G](https://github.com/universato/ac-library-rb/blob/master/document_ja/math.md)  |inv_mod|
| [◎](https://github.com/universato/ac-library-rb/blob/master/lib/crt.rb) | [◎G](https://github.com/universato/ac-library-rb/blob/master/document_ja/math.md)  |crt(Chinese remainder theorem)|
| [◎](https://github.com/universato/ac-library-rb/blob/master/lib/floor_sum.rb) | [◎G](https://github.com/universato/ac-library-rb/blob/master/document_ja/math.md) |floor_sum|
| [◎](https://github.com/universato/ac-library-rb/blob/master/lib/convolution.rb) | [◎G](https://github.com/universato/ac-library-rb/blob/master/document_ja/convolution.md) |convolution|
| [◎](https://github.com/universato/ac-library-rb/blob/master/lib/modint.rb) | [◎G](https://github.com/universato/ac-library-rb/blob/master/document_ja/modint.md) |ModInt|
| [◎](https://github.com/universato/ac-library-rb/blob/master/lib/dsu.rb) | [◎G](https://github.com/universato/ac-library-rb/blob/master/document_ja/dsu.md) |DSU(UnionFind)|
| [◎](https://github.com/universato/ac-library-rb/blob/master/lib/max_flow.rb) | [◎G](https://github.com/universato/ac-library-rb/blob/master/document_ja/max_flow.md) |MaxFlow|
| [◎](https://github.com/universato/ac-library-rb/blob/master/lib/min_cost_flow.rb) |[◎G](https://github.com/universato/ac-library-rb/blob/master/document_ja/min_cost_flow.md)  |MinCostFlow|
| [◎](https://github.com/universato/ac-library-rb/blob/master/lib/scc.rb) | [◎G](https://github.com/universato/ac-library-rb/blob/master/document_ja/scc.md) |SCC (Strongly Connected Component)|
| [◎](https://github.com/universato/ac-library-rb/blob/master/lib/two_sat.rb) | [◎G](https://github.com/universato/ac-library-rb/blob/master/document_ja/two_sat.md) |TwoSat|

## Link to Code on GitHub

### Data structure

- [fenwick_tree.rb](https://github.com/universato/ac-library-rb/blob/master/lib/fenwick_tree.rb)
- [segtree.rb](https://github.com/universato/ac-library-rb/blob/master/lib/segtree.rb)
- [lazy_segtree.rb](https://github.com/universato/ac-library-rb/blob/master/lib/lazy_segtree.rb)
- [priority_queue.rb](https://github.com/universato/ac-library-rb/blob/master/lib/priority_queue.rb)
- String
  - [suffix_array.rb](https://github.com/universato/ac-library-rb/blob/master/lib/suffix_array.rb)
  - [lcp_array.rb](https://github.com/universato/ac-library-rb/blob/master/lib/lcp_array.rb)
  - [z_algorithm.rb](https://github.com/universato/ac-library-rb/blob/master/lib/z_algorithm.rb)

### Math

- math
  - [pow_mod.rb](https://github.com/universato/ac-library-rb/blob/master/lib/pow_mod.rb)
  - [inv_mod.rb](https://github.com/universato/ac-library-rb/blob/master/lib/inv_mod.rb)
  - [crt.rb](https://github.com/universato/ac-library-rb/blob/master/lib/crt.rb)
  - [floor_sum.rb](https://github.com/universato/ac-library-rb/blob/master/lib/floor_sum.rb)
- [convolution.rb](https://github.com/universato/ac-library-rb/blob/master/lib/convolution.rb)
- [modint.rb](https://github.com/universato/ac-library-rb/blob/master/lib/modint.rb)

### Graph

- [dsu.rb](https://github.com/universato/ac-library-rb/blob/master/lib/dsu.rb)
- [max_flow.rb](https://github.com/universato/ac-library-rb/blob/master/lib/max_flow.rb)
- [min_cost_flow.rb](https://github.com/universato/ac-library-rb/blob/master/lib/min_cost_flow.rb)
- [scc.rb](https://github.com/universato/ac-library-rb/blob/master/lib/scc.rb)
- [two_sat.rb](https://github.com/universato/ac-library-rb/blob/master/lib/two_sat.rb)

## Alphabet Order Index

<details>
<summary>Alphabet Order Index</summary>

[convolution.rb](https://github.com/universato/ac-library-rb/blob/master/lib/convolution.rb)
[crt.rb](https://github.com/universato/ac-library-rb/blob/master/lib/crt.rb)
[dsu.rb](https://github.com/universato/ac-library-rb/blob/master/lib/dsu.rb)
[fenwick_tree.rb](https://github.com/universato/ac-library-rb/blob/master/lib/fenwick_tree.rb)
[floor_sum.rb](https://github.com/universato/ac-library-rb/blob/master/lib/floor_sum..rb)
[inv_mod.rb](https://github.com/universato/ac-library-rb/blob/master/lib/inv_mod.rb)
[lazy_segtree.rb](https://github.com/universato/ac-library-rb/blob/master/lib/lazy_segtree.rb)
[lcp_array.rb](https://github.com/universato/ac-library-rb/blob/master/lib/lcp_array.rb)
[max_flow.rb](https://github.com/universato/ac-library-rb/blob/master/lib/max_flow.rb)
[min_cost_flow.rb](https://github.com/universato/ac-library-rb/blob/master/lib/min_cost_flow.rb)
[modint.rb](https://github.com/universato/ac-library-rb/blob/master/lib/modint.rb)
[pow_mod.rb](https://github.com/universato/ac-library-rb/blob/master/lib/pow_mod.rb)
[priority_queue.rb](https://github.com/universato/ac-library-rb/blob/master/lib/priority_queue.rb)
[scc.rb](https://github.com/universato/ac-library-rb/blob/master/lib/scc.rb)
[segtree.rb](https://github.com/universato/ac-library-rb/blob/master/lib/segtree.rb)
[suffix_array.rb](https://github.com/universato/ac-library-rb/blob/master/lib/suffix_array.rb)
[two_sat.rb](https://github.com/universato/ac-library-rb/blob/master/lib/two_sat.rb)
[z_algorithm.rb](https://github.com/universato/ac-library-rb/blob/master/lib/z_algorithm.rb)

</details>
